/* $Id: psdebug.h,v 1.14 2006/01/16 21:15:02 rkufrin Exp $ */

/****************************************************************************
 *                    University of Illinois/NCSA
 *                        Open Source License
 * 
 *        Copyright(C) 2002-2006, The Board of Trustees of the
 *           University of Illinois. All rights reserved.
 * 
 *                            Developed by:             
 * 
 *                        The PerfSuite Project
 *           National Center for Supercomputing Applications
 *             University of Illinois at Urbana-Champaign
 * 
 *                  http://perfsuite.ncsa.uiuc.edu/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * + Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimers.
 * + Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in
 *   the documentation and/or other materials provided with the distribution.
 * + Neither the names of The PerfSuite Project, NCSA/University of Illinois
 *   at Urbana-Champaign, nor the names of its contributors may be used to
 *   endorse or promote products derived from this Software without specific
 *   prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS WITH THE SOFTWARE.
 ****************************************************************************/

#ifndef PSDEBUG_H_INCLUDED
#define PSDEBUG_H_INCLUDED 1

#if _REENTRANT
# include <pthread.h>
#endif

#include <perfsuite.h>

/*
 * debugging (debug.c)
 */

#if DEBUG
# define PS_DEBUGENV "PS_DEBUG"
# define PS_DEBUG(l,x) \
  {if (ps_debug() > l) {printf("%s:%d : ", __FILE__,__LINE__); fflush(stdout); x}}
#else
# define PS_DEBUG(l,x)
#endif

typedef enum {
    PS_DEBUG_UNINITIALIZED = -2,
    PS_DEBUG_OFF           = -1,
    PS_DEBUG_FATAL         =  0,
    PS_DEBUG_WARNING       =  1,
    PS_DEBUG_INFO          =  2,
    PS_DEBUG_VERBOSE       =  3
} ps_debuglevel_t;

BEGIN_C_DECLS
extern ps_debuglevel_t ps_debug     PARAMS((void));
extern ps_status_t ps_setdebuglevel PARAMS((void));
END_C_DECLS

#endif /* _PSDEBUG_H_INCLUDED */
