/* $Id: hwpc-papi.h,v 1.25 2013/05/07 21:51:49 ruiliu Exp $ */

/****************************************************************************
 *                    Illinois Open Source License
 *                    University of Illinois/NCSA
 *                        Open Source License
 * 
 *     Copyright(C) 2002-2006, 2013, The Board of Trustees of the
 *            University of Illinois. All rights reserved.
 * 
 *                          Developed by:             
 *
 *                      The PerfSuite Project
 *          National Center for Supercomputing Applications 
 *            University of Illinois at Urbana-Champaign
 * 
 *                http://perfsuite.ncsa.uiuc.edu/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * + Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimers.
 * + Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in
 *   the documentation and/or other materials provided with the distribution.
 * + Neither the names of The PerfSuite Project, NCSA/University of Illinois
 *   at Urbana-Champaign, nor the names of its contributors may be used to
 *   endorse or promote products derived from this Software without specific
 *   prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS WITH THE SOFTWARE.
 ****************************************************************************/

#ifndef HPWC_PAPI_H_INCLUDED
#define HWPC_PAPI_H_INCLUDED 1

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <perfsuite.h>
#include <papi.h>
#if PAPI3
# include <papicompat.h>
#endif

/*
 * PAPI version supported
 */
#if PAPI3
#define PS_PAPIVERSION 3
#else
#define PS_PAPIVERSION 2
#endif

/*
 * Thread-specific data structure
 */
struct hwpc_papi_tsd {
    int            *eventset;
    PAPI_sprofil_t *sprofils;
    /*int            papierrno;*/
};
typedef struct hwpc_papi_tsd hwpc_papi_tsd_t;

BEGIN_C_DECLS

int destroy_counters_papi  PARAMS((void));
int get_num_counters_papi  PARAMS((void));
int get_max_counters_papi  PARAMS((ps_hwpc_globals_t *globals));
int init_counters_papi     PARAMS((ps_hwpc_globals_t *globals));
int read_counters_papi     PARAMS((ps_hwpc_value_t *values));
int start_counters_papi    PARAMS((ps_hwpc_globals_t *globals));
int stop_counters_papi     PARAMS((ps_hwpc_value_t *values));
int init_profiling_papi    PARAMS((ps_hwpc_globals_t *globals,
                                   ps_hwpc_sample_t **samples));
int start_profiling_papi   PARAMS((ps_hwpc_globals_t *globals,
                                   ps_hwpc_sample_t **samples));
int suspend_profiling_papi PARAMS((ps_hwpc_globals_t *globals,
                                   ps_hwpc_sample_t **samples));
int stop_profiling_papi    PARAMS((ps_hwpc_globals_t *globals,
                                   ps_hwpc_sample_t **samples));

END_C_DECLS

/* Fortran wrappers */

#define PSF_HWPC_PAPI_WRITE_F77    F77_FUNC_(psf_hwpc_papi_write,PSF_PAPI_WRITE)
#define PSF_HWPC_PAPI_HL_WRITE_F77 F77_FUNC_(psf_hwpc_papi_hl_write,PSF_PAPI_HL_WRITE)

#endif /* HWPC_PAPI_INCLUDED */
