/* $Id: psx.h,v 1.12 2010/05/11 15:36:07 ruiliu Exp $ */

/****************************************************************************
 *
 *                      University of Illinois/NCSA
 *                          Open Source License
 * 
 *          Copyright(C) 2009-2010, The Board of Trustees of the
 *              University of Illinois. All rights reserved.
 * 
 *                             Developed by:             
 * 
 *                        The PerfSuite Project
 *            National Center for Supercomputing Applications
 *              University of Illinois at Urbana-Champaign
 * 
 *                   http://perfsuite.ncsa.uiuc.edu/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * + Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimers.
 * + Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in
 *   the documentation and/or other materials provided with the distribution.
 * + Neither the names of The PerfSuite Project, NCSA/University of Illinois
 *   at Urbana-Champaign, nor the names of its contributors may be used to
 *   endorse or promote products derived from this Software without specific
 *   prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS WITH THE SOFTWARE.
 ****************************************************************************/

#ifndef _PSX_H_INCLUDED
#define _PSX_H_INCLUDED 1

#include <perfsuite.h>

/*
 * PC->source code data structure
 */

typedef struct _ps_ip_map {
    caddr_t ip;
    const char *file;
    const char *function;
    int line;
} ps_ip_map_t;

typedef void * ps_bfd_t;

typedef enum {
    PSX_BFD_FILE_FLAG_DYNAMIC = 1,
    PSX_BFD_FILE_FLAG_EXECUTABLE,
    PSX_BFD_FILE_FLAG_HAS_RELOC,
    PSX_BFD_FILE_FLAG_HAS_LINENO,
    PSX_BFD_FILE_FLAG_HAS_DEBUG,
    PSX_BFD_FILE_FLAG_HAS_SYMS,
} psx_bfd_file_flag;


/*
 * PC->source code mapping
 */

BEGIN_C_DECLS

extern int _psx_bfd_init     PARAMS((void));
extern int _psx_bfd_open     PARAMS((char *file, ps_bfd_t *ps_bfd));
extern int _psx_bfd_close    PARAMS((ps_bfd_t ps_bfd));
extern int _psx_bfd_map      PARAMS((ps_bfd_t ps_bfd, caddr_t *ip, int nips,
                                     ps_ip_map_t *map));
extern int _psx_bfd_inquire  PARAMS((ps_bfd_t ps_bfd, 
                                     psx_bfd_file_flag inflag,
                                     int *retValue));
extern int _psx_demangle     PARAMS((const char *inStr, const char *style,
                                     char **outStr));

END_C_DECLS


#endif /* _PSX_H_INCLUDED */

